# $Id: template,v 0.3.2.1 2002/09/12 11:00:00 robert Exp $
#
# (c) 2002 by Jochen Striepe for Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_OPENSSL))
PACKAGES += openssl
endif

#
# Paths and names 
#
OPENSSL			= openssl-0.9.7
OPENSSL_URL 		= http://www.openssl.org/foo/bar/$(OPENSSL).tar.gz
OPENSSL_SOURCE		= $(SRCDIR)/$(OPENSSL).tar.gz
OPENSSL_DIR 		= $(BUILDDIR)/$(OPENSSL)
OPENSSL_EXTRACT		= gzip -dc

ifeq (y,$(PTXCONF_ARCH_ARM))
    THUD = linux-elf-arm
endif
ifeq (y,$(PTXCONF_ARCH_X86))
    THUD = linux-elf
endif
ifeq (y,$(PTXCONF_OPT_I686))
    THUD = linux-ppro
endif

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

OPENSSL_get: $(STATEDIR)/OPENSSL.get

$(STATEDIR)/OPENSSL.get: $(OPENSSL_SOURCE)
	touch $@

$(OPENSSL_SOURCE):
	@echo
	@echo --------
	@echo target: openssl.get
	@echo --------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(OPENSSL_URL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

OPENSSL_extract: $(STATEDIR)/OPENSSL.extract

$(STATEDIR)/OPENSSL.extract: $(STATEDIR)/OPENSSL.get
	@echo
	@echo ------------
	@echo target: openssl.extract
	@echo ------------
	@echo
	$(OPENSSL_EXTRACT) $(OPENSSL_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

OPENSSL_prepare: $(STATEDIR)/OPENSSL.prepare

$(STATEDIR)/OPENSSL.prepare: $(STATEDIR)/OPENSSL.extract $(STATEDIR)/zlib.install $(STATEDIR)/glibc.install
	@echo
	@echo ------------
	@echo target: openssl.prepare
	@echo ------------
	@echo
	cd $(OPENSSL_DIR) && ./Configure $(THUD) --prefix=$(PTXCONF_PREFIX) no-shared
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

OPENSSL_compile: $(STATEDIR)/OPENSSL.compile

$(STATEDIR)/OPENSSL.compile: $(STATEDIR)/OPENSSL.prepare 
	@echo
	@echo ----------------------- 
	@echo target: openssl.compile
	@echo -----------------------
	@echo
	cd $(OPENSSL_DIR) && PATH=$(PTXCONF_PREFIX)/bin:$$PATH make
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

OPENSSL_install: $(STATEDIR)/OPENSSL.install

$(STATEDIR)/OPENSSL.install: $(STATEDIR)/OPENSSL.compile
	@echo
	@echo ----------------------- 
	@echo target: openssl.install
	@echo -----------------------
	@echo
	PATH=$(PTXCONF_PREFIX)/bin:$$PATH make -C $(OPENSSL_DIR) install
	touch $@

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

OPENSSL_targetinstall: $(STATEDIR)/OPENSSL.targetinstall

$(STATEDIR)/OPENSSL.targetinstall: $(STATEDIR)/OPENSSL.install
	@echo
	@echo ------------------ 
	@echo target: openssl.targetinstall
	@echo ------------------
	@echo
	echo NO TARGET INSTALL FOR STATIC LIBS
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

OPENSSL_clean: 
	rm -rf $(STATEDIR)/OPENSSL.* $(OPENSSL_DIR)

# vim: syntax=make
